﻿Imports System.IO
Imports System.Net
Imports System.Runtime.Serialization.Json
Imports System.Text
Imports Newtonsoft.Json

Public Class PrevisaoTempo

    Shared appId As String = "numero da sua api Key"
    Shared baseUrl As String = "http://api.openweathermap.org/data/2.5/find/city?lat={0}&lon={1}&cnt={2}"

    Public Shared Function PrevisaoTempoCidade(ByVal nome As String) As WeatherInfo

        Dim client = New WebClient()
        client.Headers.Add("User-Agent", "Nobody")

        Dim url As String =
            String.Format("http://api.openweathermap.org/data/2.5/forecast/daily?q={0}&units=metric&cnt=1&APPID={1}",
                          nome.Trim(), appId)

        Try
            Dim response = client.DownloadString(New Uri(url))
            Dim previsao As WeatherInfo = JsonConvert.DeserializeObject(Of WeatherInfo)(response)
            Return previsao
        Catch ex As Exception
            Throw ex
        End Try
    End Function

    Public Shared Function PrevisaoTempoCoordenadas(latitude As Double, longitude As Double, quantidade As Integer) As WeatherInfo

        Dim url = String.Format(baseUrl, latitude, longitude, quantidade) & "APPID=" & appId

        Try
            ' Chamada sincrona
            Dim syncClient = New WebClient()
            Dim content = syncClient.DownloadString(url)

            ' Cria o serializados Json e trata a resposta
            Dim serializer As New DataContractJsonSerializer(GetType(WeatherInfo))
            Using ms = New MemoryStream(Encoding.Unicode.GetBytes(content))
                ' deserializa o objeto JSON usando o tipo de dados
                Dim weatherData = DirectCast(serializer.ReadObject(ms), WeatherInfo)
                Return weatherData
            End Using
        Catch ex As Exception
            Throw ex
        End Try
    End Function

End Class
